#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h> 
#include <string.h>

volatile sig_atomic_t end=0;

static void hdl (int sig, siginfo_t *siginfo, void *context)
{
   fprintf (stderr, "Dostal jsem signal PID: %ld, UID: %ld\n",
             (long)siginfo->si_pid, (long)siginfo->si_uid);
   end = 1;
}

int main(void)
{
   int     fd[2], nbytes;
   pid_t   child_pid1, child_pid2;
   
   if (pipe(fd) == -1) {
      perror("pipe");
      exit(2);
   }
   
   if((child_pid1 = fork()) == -1) {
      perror("fork");
      exit(1);
   }
   
   if(child_pid1 == 0) {
      int i, d1, d2, s;
      /* Child process closes up input side of pipe */
      
      close(0);
      close(fd[1]);
      
      /* Duplicate the input side of pipe to stdin */
      dup(fd[0]);
      s=2;
      for (i=0; i<50 && s==2; i++) {
         s=scanf("%i %i\n", &d1, &d2);
         if (s==2) {
            printf("Prijato %i %i\n", d1, d2);
         }
      }
      exit(0);
   } else {
      if((child_pid2 = fork()) == -1) {
         perror("fork");
         exit(1);
      }
      
      if (child_pid2 == 0) {
         int i, d1, d2;
         /* Parent process closes up output side of pipe */
         struct sigaction act;
         
         memset (&act, '\0', sizeof(act));
         act.sa_sigaction = &hdl;
         act.sa_flags = SA_SIGINFO;
         
         if (sigaction(SIGUSR1, &act, NULL) < 0) {
            perror ("sigaction");
            return 1;
         }
         
         close(1);
         close(fd[0]);
         
         dup(fd[1]);
         for(i=0; i<50 && end==0; i++) {
            d1=rand()%1000;
            d2=rand()%1000;
            fprintf(stderr, "Generovano %i %i\n", d1, d2);
            printf("%i %i\n", d1, d2);
            fflush(stdout);
            sleep(1);
         }
         exit(0);
      } else {
         sleep(5);
         kill (child_pid2, SIGUSR1);
         waitpid(-1);
         waitpid(-1);
      }
   }
   
   return(0);
}